﻿<%@ Page Language="c#" Codebehind="ConfigurationManagerPlugin.aspx.cs" AutoEventWireup="False" Inherits="EPiServer.Labs.ConfigurationManager.ConfigurationManagerPlugin" Title="Configuration Manager" %>

<asp:Content ContentPlaceHolderID="HeaderContentRegion" runat="server">
    <style type="text/css">
        .epi-default td.no-result {
            text-align: center;
            padding: 20px;
        }
    </style>
</asp:Content>

<asp:Content ContentPlaceHolderID="MainRegion" runat="server">
    <asp:Repeater ID="rptOptions" runat="server" ItemType="EPiServer.Labs.ConfigurationManager.SavedOptionsInfo" OnItemDataBound="OnOptionsItemDataBound">
        <HeaderTemplate>
            <h4 class="delimiter">List of saved Options</h4>
            <table class="epi-default" cellspacing="0" style="border-style:None;border-collapse:collapse;">
            <thead>
            <tr>
                <th scope="col">Name</th>
                <th scope="col">Is active?</th>
                <th scope="col">Is valid?</th>
                <th scope="col">Saved by</th>
                <th scope="col">Saved date</th>
                <th scope="col">Actions</th>
            </tr>
            </thead>
            <tbody>
        </HeaderTemplate>
        <ItemTemplate>
            <tr>
                <td>
                    <span><%# Item.OptionsClass %></span>
                </td>
                <td>
                    <asp:CheckBox AutoPostBack="true" runat="server" Checked="<%# Item.Active %>" OnCheckedChanged="ToggleEnabled" CausesValidation="false"/>
                    <asp:HiddenField runat="server" ID="fullTypeName" Value='<%# Item.OptionsClass %>'/>
                </td>
                <td>
                    <asp:CheckBox AutoPostBack="true" runat="server" Checked="<%# Item.IsValid %>" Enabled="false"/>
                </td>
                <td><%#: Item.UserName %></td>
                <td><%# Item.SaveDate.ToString() %></td>
                <td>
                    <span class="epi-cmsButton">
                        <asp:Button CssClass="epi-cmsButton-text epi-cmsButton-tools epi-cmsButton-Edit" runat="server"
                                    OnClick="EditConfig" Enabled="<%# Item.IsValid %>" Text="Edit" CausesValidation="false"/>
                    </span>
                    <span class="epi-cmsButton">
                        <asp:Button CssClass="epi-cmsButton-text epi-cmsButton-tools epi-cmsButton-Delete" runat="server" CausesValidation="false"
                                    OnClick="DeleteConfig" OnClientClick="return confirm('Are you sure you want delete this option?');" Text="Delete"/>
                    </span>
                </td>
            </tr>
        </ItemTemplate>
        <FooterTemplate>
            <asp:PlaceHolder ID="noItemsContainer" runat="server" Visible="false">
                <tr>
                    <td class="no-result" colspan="6">No items to show</td>
                </tr>
            </asp:PlaceHolder>
        </tbody>
        </table>
        </FooterTemplate>
    </asp:Repeater>


    <div class="epi-formArea" style="margin-top: 50px;">
        <asp:PlaceHolder ID="invalidConfiguration" runat="server" Visible="false">
            <h4 class="delimiter">Invalid initialization.</h4>
            <div class="epi-size10">
                <div>
                    In order to get ConfigurationManager to work you will have to register proxies manually.
                    Please add a new Initializable Module like this:
                    <pre>
[ModuleDependency(typeof(Web.InitializationModule))]
[InitializableModule]
public class ExplicitProxyRegistration: IConfigurableModule
{
    public void Initialize(InitializationEngine context)
    {
    }

    public void Uninitialize(InitializationEngine context)
    {
    }

    public void ConfigureContainer(ServiceConfigurationContext context)
    {
        context.ConfigurationComplete += Context_ConfigurationComplete;
    }

    private void Context_ConfigurationComplete(object sender, ServiceConfigurationEventArgs e)
    {
        var structureMapConfiguration = (StructureMapConfiguration) e.Services;
        var container = structureMapConfiguration.Container;

        EPiServer.Labs.ConfigurationManager.ConfigInitializer.
            RegisterOptionsProxies(container, structureMapConfiguration);
    }
}
                    </pre>
                </div>
            </div>
        </asp:PlaceHolder>

        <asp:PlaceHolder ID="validConfiguration" runat="server" Visible="true">
            <h4 class="delimiter">
                <asp:Label runat="server" ID="lblInfo" Text="Create new"/>
            </h4>

            <div class="epi-size10">
                <div>
                    <asp:Label runat="server" AssociatedControlID="ddlOptionTypes">Option Type</asp:Label>
                    <asp:DropDownList AutoPostBack="true" runat="server" ID="ddlOptionTypes" Width="500" DataTextField="FullName"
                                      DataValueField="AssemblyQualifiedName" OnSelectedIndexChanged="OnSelectedTypeChanged"/>
                </div>
            </div>

            <h4 class="delimiter">Settings</h4>
            <div class="epi-size10">
                <div>
                    <asp:Label runat="server" AssociatedControlID="tbDetails">Serialized Value</asp:Label>
                    <asp:TextBox runat="server" TextMode="MultiLine" ID="tbDetails" Columns="80" Rows="20" Width="500"/>
                    <asp:RequiredFieldValidator runat="server" Display="None" ErrorMessage="Invalid JSON" ControlToValidate="tbDetails"/>
                    <asp:RequiredFieldValidator runat="server" Display="None" ErrorMessage="Type is required" ControlToValidate="ddlOptionTypes"/>
                    <asp:CustomValidator runat="server" OnServerValidate="ValidateJson" Display="None" ErrorMessage="Invalid JSON"/>
                </div>
            </div>

            <div class="epi-buttonContainer">
                <span class="epi-cmsButton">
                    <asp:Button CssClass="epi-cmsButton-text epi-cmsButton-tools epi-cmsButton-Save" runat="server" Text="Save" OnClick="SaveConfig"/>
                </span>
            </div>
        </asp:PlaceHolder>
    </div>
</asp:Content>
